use std::{io::{Stdout, Write}, ops::BitOrAssign, time::Duration};

use axum::response::sse::Event;
use clap::builder::NonEmptyStringValueParser;
use lib::{client::Client, message::{Message, MessageKind}, message_read::MessageReader, player::Player};
use crossterm::{
    cursor, event::{self, poll, Event as TermEvent, KeyCode, KeyModifiers}, execute, queue, style, terminal::{
        disable_raw_mode, enable_raw_mode, Clear, ClearType, EnableLineWrap, EnterAlternateScreen
    }
};
use tokio::io::{self, AsyncReadExt, AsyncWriteExt};

const HELP: &str = r#"CIAOTERPIA
atm posso fare questo:
(ricorda di premere i bottoni)
- '1' mando giocante
- '2' mando lobbando (futuro)
"#;

fn create_message_player(player: &Player) -> anyhow::Result<Message, anyhow::Error> {
    Message::new(
        &player.get_name(),
        MessageKind::Test,
        player.encode()?
    )
}

<<<<<<< HEAD
    let (mut rd, mut wr) = io::split(client.stream);
||||||| 45f9b5b
    // tokio::task::spawn(async move {
        client.send_message(Message::new(&local_address.to_string(), MessageKind::Test, "test json").unwrap()).await.expect("failed to write to socket");
=======
async fn delete_player(player: &Player, client: reqwest::Client, addr: &str) -> anyhow::Result<()> {
    let player_id = &player.name;
    let response = client
        .get([&addr, "/delete/", &player_id].concat())
        .send().await;
>>>>>>> deke/ipertesto

<<<<<<< HEAD
    let mut buf: Vec<u8> = Vec::with_capacity(4);
    let mut message_reader = MessageReader::new();
||||||| 45f9b5b
        // let (mut rd, mut wr) = client.stream.split();
=======
    if let Err(e) = &response {
        println!("{e}\n");
        return Ok(())
    }
>>>>>>> deke/ipertesto

<<<<<<< HEAD
    loop {
        match rd.read_exact(&mut buf).await {
            Ok(0) => {
                println!("connection closed by server");
                continue;
            },
            Ok(n) => {
                let mut buf = Vec::with_capacity(n);
                rd.read_exact(&mut buf).await?;
                let message = message_reader.read(&buf)?;
                println!("{:?}", message);
            },
            Err(e) => eprintln!("failed reading from socket: {}", e),
        }
    }
||||||| 45f9b5b
        // let mut message_reader = MessageReader::new();
    
        // 'handler: loop {
        //     let mut buffer = vec![];
        //     if tokio::io::copy(&mut rd, &mut buffer).await.is_err() {
        //         println!("failed to copy");
        //     }
=======
    println!("{}", response?.text().await?);

    Ok(())
}

async fn send_player(player: &Player, client: reqwest::Client, addr: &str) -> anyhow::Result<()> {
    let player_message = create_message_player(&player)?;
    let response = client
        .post([&addr, "/create/player"].concat())
        .header("Content-Type", "application/json")
        .body(player_message.encode()?)
        .send().await;

    if let Err(e) = &response {
        println!("{e}\n");
        return Ok(())
    }

    println!("{}", response?.text().await?);

    Ok(())
}
async fn handle_terminal(player: &Player, stdout: &mut Stdout, client: reqwest::Client, addr: &str) -> anyhow::Result<()> {
    'handler: loop {
        while let Ok(_event_happened) = poll(Duration::from_millis(2)) {
            match event::read().expect("diomerds") {
                TermEvent::Key(key) => {
                    match (key.code, key.modifiers) {
                        (KeyCode::Char('c'), KeyModifiers::CONTROL) => break 'handler,
                        (KeyCode::Char('h'), KeyModifiers::NONE) => {
                            for line in HELP.split('\n') {
                                println!("{line}")
                            }
                        }, 
                        (KeyCode::Char('1'), KeyModifiers::NONE) => {
                            send_player(&player, client.clone(), addr).await?;
                        },
                        (KeyCode::Char('2'), KeyModifiers::NONE) => {
                            delete_player(&player, client.clone(), addr).await?;
                        },
                        (_, _) => println!("{:?}\n", key),
                    }
                },
                _ => continue,
            }
        }
    }

    Ok(())
}

#[tokio::main]
pub async fn main() -> anyhow::Result<()> {
    let mut stdout = std::io::stdout();

    enable_raw_mode()?;
    execute!(
        stdout,
        Clear(ClearType::All),
        EnableLineWrap,
        cursor::Show,
        cursor::EnableBlinking,
        EnterAlternateScreen,
    )?;

    let player = Player::new()?;

    let addr = "http://127.0.0.1:8080";
    let client = reqwest::Client::new();

    // println!("{}", HELP);

    handle_terminal(&player, &mut stdout, client.clone(), &addr).await?;
    disable_raw_mode()?;
>>>>>>> deke/ipertesto

<<<<<<< HEAD
    // loop {
    //     let n = rd.read_exact(&mut buf).await.expect("fallito lettura");

    //     if n == 0 {
    //         break;
    //     }

    //     let message =  message_reader.read(&buf)?;
    //     println!("GOT {:?}", message);

    //     let response = match &message.message_kind {
    //         MessageKind::Test => Message::new(&local_address.to_string(), MessageKind::Test, "risposta")?.as_bytes_vec()?,
    //         MessageKind::Move => todo!(),
    //         MessageKind::CreatePlayer => todo!(),
    //         MessageKind::CreateLobby => todo!(),
    //     };

    //     wr.write_all(&response.as_bytes()).await?;

    //     buf.clear();
    //     message_reader.buffer.clear();
    //     break;
    // }

    // disable_raw_mode()?;

||||||| 45f9b5b

        //     let message =  message_reader.read(&buffer).expect("failed to read from socket");
        //     println!("{:?}", message);

        //     break 'handler;
        // }
    // });
    // client.send_message(Message::new(&local_address.to_string(), MessageKind::Test, "test json").unwrap()).await?;

    // let (mut rd, mut wr) = client.stream.split();

    // let mut message_reader = MessageReader::new();
    
    // 'handler: loop {
    //     let mut buffer = vec![];
    //     if tokio::io::copy(&mut rd, &mut buffer).await.is_err() {
    //         println!("failed to copy");
    //     }

    //     let message =  message_reader.read(&buffer)?;
    //     println!("{:?}", message);

    //     break 'handler;
    // }

    // disable_raw_mode()?;
=======
>>>>>>> deke/ipertesto
    Ok(())
}
